Attribute VB_Name = "Module1"
Option Explicit

Private Const DURCHLAEUFE As Long = 100&
Private Const ZAHLEN As Long = 500&
Private Const KLEINSTEZAHL As Long = 1000&
Private Const GROESSTEZAHL As Long = 1000000000

Private Sub Main()
    '   Stopuhr anlegen
    Dim objStopuhr As clsStopUhr
    Set objStopuhr = New clsStopUhr
    objStopuhr.Calibrieren
    
    '   Ergebnisfeld dimensionieren
    '   (Element 0 gibt spter den Durchschnitt an)
    Dim Ergebnisse(0 To DURCHLAEUFE, 1 To 3) As Double
    
    '   Rohzahlenfeld und Kopie davon dimensionieren
    Dim Zahlenfeld(1 To ZAHLEN) As Long
    Dim tz(1 To ZAHLEN) As Long
    
    '   Laufvariablen
    Dim i As Long, j As Long
    
    '   Zufallszahlen erzeugen
    For i = LBound(Zahlenfeld) To UBound(Zahlenfeld)
        Zahlenfeld(i) = Int((GROESSTEZAHL - KLEINSTEZAHL + 1) * Rnd) + _
                        KLEINSTEZAHL
    Next i
    
    '   Laufzeiten messen
    For j = LBound(Ergebnisse, 1) + 1 To UBound(Ergebnisse, 1)
        '   Laufzeiten mit Variante 1 messen
        For i = LBound(tz) To UBound(tz)
            tz(i) = Zahlenfeld(i)
        Next i
        objStopuhr.Start
        For i = LBound(tz) To UBound(tz)
            tz(i) = Quersumme1(tz(i))
        Next i
        objStopuhr.Halt
        Ergebnisse(j, 1) = objStopuhr.RunTime
        Ergebnisse(LBound(Ergebnisse, 1), 1) = _
                            Ergebnisse(LBound(Ergebnisse, 1), 1) + _
                            Ergebnisse(j, 1)
        
        '   Laufzeiten mit Variante 2 messen
        For i = LBound(tz) To UBound(tz)
            tz(i) = Zahlenfeld(i)
        Next i
        objStopuhr.Start
        For i = LBound(tz) To UBound(tz)
            tz(i) = Quersumme2(tz(i))
        Next i
        objStopuhr.Halt
        Ergebnisse(j, 2) = objStopuhr.RunTime
        Ergebnisse(LBound(Ergebnisse, 1), 2) = _
                            Ergebnisse(LBound(Ergebnisse, 1), 2) + _
                            Ergebnisse(j, 2)
        
        '   Laufzeiten mit Variante 3 messen
        For i = LBound(tz) To UBound(tz)
            tz(i) = Zahlenfeld(i)
        Next i
        objStopuhr.Start
        For i = LBound(tz) To UBound(tz)
            tz(i) = Quersumme3(tz(i))
        Next i
        objStopuhr.Halt
        Ergebnisse(j, 3) = objStopuhr.RunTime
        Ergebnisse(LBound(Ergebnisse, 1), 3) = _
                            Ergebnisse(LBound(Ergebnisse, 1), 3) + _
                            Ergebnisse(j, 3)
    Next j
    
    '   Durchschnittswerte berechnen und ausgeben
    For j = 1 To 3
        Ergebnisse(LBound(Ergebnisse, 1), j) = _
                            Ergebnisse(LBound(Ergebnisse, 1), j) / _
                            DURCHLAEUFE
        Debug.Print "Variante " & CStr(j) & _
                    " bentigte durchschnittlich " & FormatNumber( _
                    Ergebnisse(LBound(Ergebnisse, 1), j), 6) & _
                    " Sekunden"
    Next j
    
    
    '   Stopuhr entfernen
    Set objStopuhr = Nothing
End Sub

Function Quersumme1(ByVal n As Long) As Long
    Dim Result As Long
    
    n = Abs(n)

    Do While n <> 0
        Result = Result + n Mod 10
        n = n \ 10
    Loop
    
    Quersumme1 = Result
End Function

Function Quersumme2(ByVal n As Long) As Long
    Dim i As Long
    Dim s As String
    
    s = CStr(Abs(n))
    n = 0
    
    For i = 1 To Len(s)
        n = n + CLng(Mid$(s, i, 1))
    Next i
    
    Quersumme2 = n
End Function

Function Quersumme3(ByVal n As Long) As Long
    Select Case n
        Case Is < 0
            Quersumme3 = Quersumme3(-n)

        Case Is < 10
            Quersumme3 = n

        Case Else
            Quersumme3 = (n Mod 10) + Quersumme3(n \ 10)

    End Select
End Function
